]> Kevux Git Server - kevux-tools/commitdiff
Update: Add some basic, initial, files.
authorKevin Day <thekevinday@gmail.com>
Tue, 13 Dec 2022 04:43:18 +0000 (22:43 -0600)
committerKevin Day <thekevinday@gmail.com>
Tue, 13 Dec 2022 04:43:18 +0000 (22:43 -0600)
Provide the initial readme files (more changes to come).

Provide the install.sh file, copied from the FLL project.

Add the different license files for the licenses to be used.

In general, all source code is under the LGPL2.1 or greater license.
In general, all specifications and specification documentation are under the Open Standard License 1.0.
In general, all non-specification and non-specification documentation is under CC By SA 4.0.

documents/readme.build.txt [new file with mode: 0644]
documents/readme.txt [new file with mode: 0644]
install.sh [new file with mode: 0755]
licenses/cc-by-sa-4.0 [new file with mode: 0644]
licenses/lgpl-2.1-or-later [new file with mode: 0644]
licenses/open-standard-license-1.0 [new file with mode: 0644]

diff --git a/documents/readme.build.txt b/documents/readme.build.txt
new file mode 100644 (file)
index 0000000..da87dfb
--- /dev/null
@@ -0,0 +1,32 @@
+# fss-0002 iki-0000
+#
+# license: cc-by-sa-4.0
+#
+# This file (assumed to be named readme.build.txt) can be more easily read using the following iki_read commands:
+#   iki_read readme.build.txt +Q -w -rr abbreviation-FLL FLL abbreviation-FSS FSS -WW character "'" "'" code '"' '"'
+#
+# To read the "Build Readme Documentation" section of this file, use this command sequence:
+#   fss_basic_list_read readme.build.txt +Q -cn "Build Readme Documentation" | iki_read +Q -w -rr abbreviation-FLL FLL abbreviation-FSS FSS -WW character "'" "'" code '"' '"'
+#
+
+Build Readme Documentation:
+  This project is intended to be built using the bold:"Featureless Make" program.
+
+  The build system does not normally handle installation.
+  The installation process should generally be handled by a distributor or by a system administrator.
+  A very basic install process is added for convenience through an file:"install.sh" script.
+
+  The files may also be manually copied as desired if not using the file:"install.sh" script.
+
+  All built file are provided within the file:"build/" directory by default.
+  This directory may have the following notable directories\:
+    - code:"documents": Holds any documents for installation (often installed somewhere within file:"/usr/share" or file:"/usr/local/share").
+    - code:"libraries": Holds any shared or static library files (often install somewhere within either file:"/usr/lib" or file:"/usr/local/lib").
+    - code:"programs": Holds any executable files (often installed somewhere within file:"/usr/bin" or file:"/usr/local/bin").
+    - code:"settings": Holds any settings files (often installed somewhere within file:"/etc" or file:"/usr/local/etc").
+
+  Build Example, using "make"\:
+    code:"fake"
+
+  See: The abbreviation-FLL:"Featureless Linux Library" bold:"Featureless Make" project documents for further details on how to use the bold:"Featureless Make" system.
+  See: The abbreviation-FLL:"Featureless Linux Library" bold:"Featureless Make" project specifications for how to configure the write abbreviation-FSS:"Featureless Settings Specification" files.
diff --git a/documents/readme.txt b/documents/readme.txt
new file mode 100644 (file)
index 0000000..2306f92
--- /dev/null
@@ -0,0 +1,34 @@
+# fss-0002 iki-0000
+#
+# license: cc-by-sa-4.0
+#
+# This file (assumed to be named readme.build.txt) can be more easily read using the following iki_read commands:
+#   iki_read readme.txt +Q -w -rrr abbreviation-API API abbreviation-FLL FLL abbreviation-FSS FSS -WW character "'" "'" code '"' '"'
+#
+# To read the "Readme Documentation" section of this file, use this command sequence:
+#   fss_basic_list_read readme.txt +Q -cn "Readme Documentation" | iki_read +Q -w -rrr abbreviation-API API abbreviation-FLL FLL abbreviation-FSS FSS -WW character "'" "'" code '"' '"'
+#
+
+Readme Documentation:
+  The bold:"Kevux Tools" (code:"kevux-tools") project provides several tools intended and design for bold:"Kevux" software, such as the bold:"Turtle Kevux Linux Distribution".
+
+  This has been inspired by several reasons\:
+    - Annoyance with problematic tools encountered during the build and compilation of a standard bold:"Linux" toolchain from scratch.
+      Programs such as the standard bold:"Linux" code:"install" (from bold:"GNU Coreutils") has some seriously simple problems such as being incapable of properly installing files when the file:"/proc" file system is mounted.
+      The reason for the failure (be it a bug or otherwise) is unclear but the dependency on code:"/proc" being mounted is ridiculous.
+
+    - Better prepare for future planned functionality such as improved accessibility and interaction.
+      This should help make the bold:"Turtle Kevux" distribution more ready in regards to the designers and developers future plans.
+
+    - A need to improve maintainability of basic toolchain dependencies.
+      Using a project already maintained by the same person who builds and writes both the abbreviation-FLL:"Featureless Linux Library" and the bold:"Turtle Kevux" distribution makes this even easier.
+      Having fewer third-party dependencies to monitor and work with can make development and maintenance a lot easier when those replaced dependencies are simple enough.
+
+    - Provides more exposure to the abbreviation-FLL:"Featureless Linux Library".
+      This results in more testing through real-word use.
+
+    - Makes the system more familiar.
+      The developer behind both the abbreviation-FLL:"Featureless Linux Library" and this project can work better in a more comfortable environment.
+
+  See: file:"dependencies" for specific dependencies of this project.
+  See: file:"readme.build.txt" for notes building (compiling) and installing.
diff --git a/install.sh b/install.sh
new file mode 100755 (executable)
index 0000000..0dcda72
--- /dev/null
@@ -0,0 +1,812 @@
+#!/bin/bash
+# license: lgpl-2.1-or-later
+# programmer: Kevin Day
+#
+# The purpose of this script is to provide a simple installer tool to copy any part of the FLL project onto a system.
+# This assumes the destination directories already exist and does not attempt to create them.
+# Ideally, the package manager of the system should be used, but this is provided as a guide or a fallback.
+# Settings files are not copied over, but a warning will be printed to inform the installer of their existence.
+#
+# The dependencies of this script are: bash, grep, and sed.
+#
+# This script can also be run under zsh rather than bash by setting the environment variable SHELL_ENGINE to "zsh", such as:
+#   SHELL_ENGINE="zsh" zsh ./install.sh --help
+#
+
+install_main() {
+
+  if [[ $SHELL_ENGINE == "zsh" ]] ; then
+    emulate ksh
+  fi
+
+  local public_name="Simple FLL Project Install Script"
+  local system_name=install
+  local called_name=$(basename $0)
+  local version=0.7.0
+
+  local grab_next=
+  local do_color=dark
+  local do_help=
+  local i=0
+  local p=
+  local t=0
+  local key=
+
+  local c_reset="\\033[0m"
+  local c_title="\\033[1;33m"
+  local c_error="\\033[1;31m"
+  local c_warning="\\033[0;33m"
+  local c_highlight="\\033[1;32m"
+  local c_notice="\\033[0;01m"
+  local c_important="\\033[0;32m"
+  local c_subtle="\\033[1;30m"
+  local c_prefix="\\"
+
+  local -A variables=()
+  local settings_file=data/build/settings
+  local operation=
+  local operation_failure=
+  local verbosity=normal
+  local verbose=
+  local verbose_common=
+
+  local path_build=build/
+  local path_programs=programs/
+  local path_includes=includes/
+  local path_libraries=libraries/
+  local path_settings=settings/
+  local path_static=static/
+  local path_shared=shared/
+
+  local destination_prefix=/usr/local/
+  local destination_programs=bin/
+  local destination_includes=include/
+  local destination_libraries=lib/
+  local destination_libraries_static=
+  local destination_libraries_shared=
+  local destination_programs_static=
+  local destination_programs_shared=
+
+  local work=
+
+  local enable_shared=
+  local enable_shared_programs=
+  local enable_shared_libraries=
+  local enable_static=
+  local enable_static_programs=
+  local enable_static_libraries=
+  local enable_includes=yes
+
+  if [[ $# -gt 0 ]] ; then
+    t=$#
+
+    while [[ $i -lt $t ]] ; do
+      let i=$i+1
+
+      if [[ $SHELL_ENGINE == "zsh" ]] ; then
+        p=${(P)i}
+      else
+        p=${!i}
+      fi
+
+      if [[ $grab_next == "" ]] ; then
+        if [[ $p == "-h" || $p == "--help" ]] ; then
+          do_help=yes
+        elif [[ $p == "+d" || $p == "++dark" ]] ; then
+          do_color=dark
+          context="+d"
+        elif [[ $p == "+l" || $p == "++light" ]] ; then
+          do_color=light
+          context="+l"
+        elif [[ $p == "+n" || $p == "++no_color" ]] ; then
+          do_color=none
+          context="+n"
+        elif [[ $p == "+q" || $p == "++quiet" ]] ; then
+          verbosity="quiet"
+          verbose="+q"
+          verbose_common=
+        elif [[ $p == "+N" || $p == "++normal" ]] ; then
+          verbosity=
+          verbose="+N"
+          verbose_common=
+        elif [[ $p == "+V" || $p == "++verbose" ]] ; then
+          verbosity="verbose"
+          verbose="+V"
+          verbose_common="-v"
+        elif [[ $p == "+D" || $p == "++debug" ]] ; then
+          verbosity="debug"
+          verbose="+D"
+          verbose_common="-v"
+        elif [[ $p == "+v" || $p == "++version" ]] ; then
+          echo $version
+          return
+        elif [[ $p == "-b" || $p == "--build" ]] ; then
+          grab_next=path_build
+        elif [[ $p == "-s" || $p == "--settings" ]] ; then
+          grab_next=settings_file
+        elif [[ $p == "-P" || $p == "--prefix" ]] ; then
+          grab_next=prefix
+        elif [[ $p == "-B" || $p == "--bindir" ]] ; then
+          grab_next=bindir
+        elif [[ $p == "-I" || $p == "--includedir" ]] ; then
+          grab_next=includedir
+        elif [[ $p == "-L" || $p == "--libdir" ]] ; then
+          grab_next=libdir
+        elif [[ $p == "-w" || $p == "--work" ]] ; then
+          grab_next=work
+        elif [[ $p == "--enable-shared" ]] ; then
+          enable_shared="yes"
+        elif [[ $p == "--disable-shared" ]] ; then
+          enable_shared="no"
+        elif [[ $p == "--disable-shared-programs" ]] ; then
+          enable_shared_programs="no"
+        elif [[ $p == "--disable-shared-libraries" ]] ; then
+          enable_shared_libraries="no"
+        elif [[ $p == "--disable-static-programs" ]] ; then
+          enable_static_programs="no"
+        elif [[ $p == "--disable-static-libraries" ]] ; then
+          enable_static_libraries="no"
+        elif [[ $p == "--enable-static" ]] ; then
+          enable_static="yes"
+        elif [[ $p == "--disable-static" ]] ; then
+          enable_static="no"
+        elif [[ $p == "--enable-includes" ]] ; then
+          enable_includes="yes"
+        elif [[ $p == "--disable-includes" ]] ; then
+          enable_includes="no"
+        elif [[ $p == "--libraries-static" ]] ; then
+          grab_next="destination_libraries_static"
+        elif [[ $p == "--libraries-shared" ]] ; then
+          grab_next="destination_libraries_shared"
+        elif [[ $p == "--programs-static" ]] ; then
+          grab_next="destination_programs_static"
+        elif [[ $p == "--programs-shared" ]] ; then
+          grab_next="destination_programs_shared"
+        elif [[ $operation_failure == "" ]] ; then
+          operation="$p"
+          operation_failure=fail-unsupported
+        fi
+      else
+        if [[ $grab_next == "path_build" ]] ; then
+          path_build=$(echo $p | sed -e 's|^//*|/|' -e 's|/*$|/|')
+        elif [[ $grab_next == "settings_file" ]] ; then
+          settings_file=$(echo $p | sed -e 's|^//*|/|' -e 's|^//*|/|')
+        elif [[ $grab_next == "prefix" ]] ; then
+          destination_prefix=$(echo $p | sed -e 's|^//*|/|' -e 's|/*$|/|')
+        elif [[ $grab_next == "bindir" ]] ; then
+          destination_programs=$(echo $p | sed -e 's|^//*|/|' -e 's|/*$|/|')
+        elif [[ $grab_next == "includedir" ]] ; then
+          destination_includes=$(echo $p | sed -e 's|^//*|/|' -e 's|/*$|/|')
+        elif [[ $grab_next == "libdir" ]] ; then
+          destination_libraries=$(echo $p | sed -e 's|^//*|/|' -e 's|/*$|/|')
+        elif [[ $grab_next == "work" ]] ; then
+          work=$(echo $p | sed -e 's|^//*|/|' -e 's|/*$|/|')
+        elif [[ $grab_next == "destination_libraries_static" ]] ; then
+          destination_libraries_static=$(echo $p | sed -e 's|^//*|/|' -e 's|/*$|/|')
+        elif [[ $grab_next == "destination_libraries_shared" ]] ; then
+          destination_libraries_shared=$(echo $p | sed -e 's|^//*|/|' -e 's|/*$|/|')
+        elif [[ $grab_next == "destination_programs_static" ]] ; then
+          destination_programs_static=$(echo $p | sed -e 's|^//*|/|' -e 's|/*$|/|')
+        elif [[ $grab_next == "destination_programs_shared" ]] ; then
+          destination_programs_shared=$(echo $p | sed -e 's|^//*|/|' -e 's|/*$|/|')
+        fi
+
+        grab_next=
+      fi
+    done
+
+    p=
+  fi
+
+  install_handle_colors
+
+  if [[ $do_help == "yes" ]] ; then
+    install_help
+    install_cleanup
+
+    return 0
+  fi
+
+  if [[ $operation_failure == "fail-unsupported" ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: The operation ${c_notice}$operation${c_error} was not recognized.${c_reset}"
+    fi
+
+    install_cleanup
+
+    return 1
+  fi
+
+  if [[ ! -d $path_build ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: The build path ${c_notice}$path_build${c_error} is not a valid directory.${c_reset}"
+    fi
+
+    install_cleanup
+
+    return 1
+  fi
+
+  if [[ $work == "" && $destination_prefix != "" && ! -d $destination_prefix ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: The destination prefix ${c_notice}$destination_prefix${c_error} is not a valid directory.${c_reset}"
+    fi
+
+    install_cleanup
+
+    return 1
+  fi
+
+  if [[ $destination_prefix != "" ]] ; then
+    if [[ $(echo $destination_programs | grep -o '^/') == "" ]] ; then
+      destination_programs="$destination_prefix$destination_programs"
+    fi
+
+    if [[ $(echo $destination_includes | grep -o '^/') == "" ]] ; then
+      destination_includes="$destination_prefix$destination_includes"
+    fi
+
+    if [[ $(echo $destination_libraries | grep -o '^/') == "" ]] ; then
+      destination_libraries="$destination_prefix$destination_libraries"
+    fi
+  fi
+
+  if [[ $destination_libraries_static != "" ]] ; then
+    if [[ $(echo $destination_libraries_static | grep -o '^/') == "" ]] ; then
+      destination_libraries_static=$destination_libraries$destination_libraries_static
+    fi
+  else
+    destination_libraries_static=$destination_libraries
+  fi
+
+  if [[ $destination_libraries_shared != "" ]] ; then
+    if [[ $(echo $destination_libraries_shared | grep -o '^/') == "" ]] ; then
+      destination_libraries_shared=$destination_libraries$destination_libraries_shared
+    fi
+  else
+    destination_libraries_shared=$destination_libraries
+  fi
+
+  if [[ $destination_programs_static != "" ]] ; then
+    if [[ $(echo $destination_programs_static | grep -o '^/') == "" ]] ; then
+      destination_programs_static=$destination_programs$destination_programs_static
+    fi
+  else
+    destination_programs_static=$destination_programs
+  fi
+
+  if [[ $destination_programs_shared != "" ]] ; then
+    if [[ $(echo $destination_programs_shared | grep -o '^/') == "" ]] ; then
+      destination_programs_shared=$destination_programs$destination_programs_shared
+    fi
+  else
+    destination_programs_shared=$destination_programs
+  fi
+
+  if [[ $work != "" && ! -d $work ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: The work directory ${c_notice}$work${c_error} is not a valid directory.${c_reset}"
+    fi
+
+    install_cleanup
+
+    return 1
+  fi
+
+  if [[ $work == "" && ! -d $destination_programs ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: The destination bindir ${c_notice}$destination_programs${c_error} is not a valid directory.${c_reset}"
+    fi
+
+    install_cleanup
+
+    return 1
+  fi
+
+  if [[ $work == "" && ! -d $destination_programs_static ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: The destination (${c_notice}static${c_error}) bindir ${c_notice}$destination_programs_static${c_error} is not a valid directory.${c_reset}"
+    fi
+
+    install_cleanup
+
+    return 1
+  fi
+
+  if [[ $work == "" && ! -d $destination_programs_shared ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: The destination (${c_notice}shared${c_error}) bindir ${c_notice}$destination_programs_shared${c_error} is not a valid directory.${c_reset}"
+    fi
+
+    install_cleanup
+
+    return 1
+  fi
+
+  if [[ $work == "" && ! -d $destination_includes ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: The destination incluedir ${c_notice}$destination_includes${c_error} is not a valid directory.${c_reset}"
+    fi
+
+    install_cleanup
+
+    return 1
+  fi
+
+  if [[ $work == "" && ! -d $destination_libraries_static ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: The destination (${c_notice}static${c_error}) libdir ${c_notice}$destination_libraries_static${c_error} is not a valid directory.${c_reset}"
+    fi
+
+    install_cleanup
+
+    return 1
+  fi
+
+  if [[ $work == "" && ! -d $destination_libraries_shared ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: The destination (${c_notice}shared${c_error}) libdir ${c_notice}$destination_libraries_shared${c_error} is not a valid directory.${c_reset}"
+    fi
+
+    install_cleanup
+
+    return 1
+  fi
+
+  install_load_settings
+
+  install_perform_install
+
+  install_cleanup
+
+  return 0
+}
+
+install_handle_colors() {
+
+  if [[ $do_color == "light" ]] ; then
+    c_error="\\033[1;31m"
+    c_warning="\\033[0;31m"
+    c_title="\\033[1;34m"
+    c_highlight="\\033[0;34m"
+    c_notice="\\033[0;01m"
+    c_important="\\033[0;35m"
+  elif [[ $do_color == "none" ]] ; then
+    c_reset=
+    c_title=
+    c_error=
+    c_warning=
+    c_highlight=
+    c_notice=
+    c_important=
+    c_subtle=
+    c_prefix=
+  fi
+}
+
+install_help() {
+
+  echo
+  echo -e "${c_title}${public_name}${c_reset}"
+  echo -e " ${c_notice}Version ${version}${c_reset}"
+  echo
+  echo -e "${c_highlight}${system_name}${c_reset} ${c_notice}[${c_reset} options ${c_notice}]${c_reset}"
+  echo
+  echo -e "${c_highlight}Options:${c_reset}"
+  echo -e " -${c_important}h${c_reset}, --${c_important}help${c_reset}      Print this help screen."
+  echo -e " +${c_important}d${c_reset}, ++${c_important}dark${c_reset}      Use color modes that show up better on dark backgrounds."
+  echo -e " +${c_important}l${c_reset}, ++${c_important}light${c_reset}     Use color modes that show up better on light backgrounds."
+  echo -e " +${c_important}n${c_reset}, ++${c_important}no_color${c_reset}  Do not use color."
+  echo -e " +${c_important}q${c_reset}, ++${c_important}quiet${c_reset}     Decrease verbosity, silencing most output."
+  echo -e " +${c_important}N${c_reset}, ++${c_important}normal${c_reset}    Set verbosity to normal."
+  echo -e " +${c_important}V${c_reset}, ++${c_important}verbose${c_reset}   Increase verbosity beyond normal output."
+  echo -e " +${c_important}D${c_reset}, ++${c_important}debug${c_reset}     Enable debugging, significantly increasing verbosity beyond normal output."
+  echo -e " +${c_important}v${c_reset}, ++${c_important}version${c_reset}   Print the version number of this program."
+  echo
+  echo -e "${c_highlight}Install Options:${c_reset}"
+  echo -e " -${c_important}b${c_reset}, --${c_important}build${c_reset}       Custom build directory."
+  echo -e " -${c_important}s${c_reset}, --${c_important}settings${c_reset}    Custom build settings file."
+  echo -e " -${c_important}P${c_reset}, --${c_important}prefix${c_reset}      Custom destination prefix."
+  echo -e " -${c_important}B${c_reset}, --${c_important}bindir${c_reset}      Custom destination bin/ directory."
+  echo -e " -${c_important}I${c_reset}, --${c_important}includedir${c_reset}  Custom destination include/ directory."
+  echo -e " -${c_important}L${c_reset}, --${c_important}libdir${c_reset}      Custom destination lib/ directory."
+  echo -e " -${c_important}w${c_reset}, --${c_important}work${c_reset}        Install to this directory instead of system."
+  echo
+  echo -e "${c_highlight}Special Options:${c_reset}"
+  echo -e " --${c_important}enable-shared${c_reset}             Forcibly do install shared files."
+  echo -e " --${c_important}disable-shared${c_reset}            Forcibly do not install shared files."
+  echo -e " --${c_important}disable-shared-programs${c_reset}   Forcibly do not install shared programs."
+  echo -e " --${c_important}disable-shared-libraries${c_reset}  Forcibly do not install shared libraries."
+  echo -e " --${c_important}enable-static${c_reset}             Forcibly do install static files."
+  echo -e " --${c_important}disable-static${c_reset}            Forcibly do not install static files."
+  echo -e " --${c_important}disable-static-programs${c_reset}   Forcibly do not install shared programs."
+  echo -e " --${c_important}disable-static-libraries${c_reset}  Forcibly do not install shared libraries."
+  echo -e " --${c_important}enable-includes${c_reset}           Forcibly do not install include files."
+  echo -e " --${c_important}disable-includes${c_reset}          Forcibly do not install include files."
+  echo -e " --${c_important}libraries-static${c_reset}          Custom destination for static libraries."
+  echo -e " --${c_important}libraries-shared${c_reset}          Custom destination for shared libraries."
+  echo -e " --${c_important}programs-static${c_reset}           Custom destination for static programs."
+  echo -e " --${c_important}programs-shared${c_reset}           Custom destination for shared programs."
+  echo
+}
+
+install_id() {
+  local name=$1
+
+  case $name in
+    "build_sources_library") let key=1;;
+    "build_sources_program") let key=2;;
+    "build_sources_headers") let key=3;;
+    "build_sources_setting") let key=4;;
+    "build_shared") let key=5;;
+    "build_static") let key=6;;
+  esac
+}
+
+install_load_settings() {
+  local failure=
+  local i=
+  local key=
+
+  if [[ $settings_file == "" ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: No settings file has been defined.${c_reset}"
+    fi
+
+    failure=1
+  elif [[ ! -f $settings_file ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo -e "${c_error}ERROR: No settings file ${c_notice}${settings_file}${c_error} could not be found or is not a valid file.${c_reset}"
+    fi
+
+    failure=1
+  fi
+
+  if [[ $failure != "" ]] ; then
+    install_cleanup
+    exit $failure
+  fi
+
+  for i in build_sources_library build_sources_program build_sources_headers build_sources_setting build_shared build_static ; do
+
+    install_id "$i"
+
+    variables[$key]=$(grep -s -o "^[[:space:]]*${i}\>.*$" $settings_file | sed -e "s|^[[:space:]]*${i}\>||" -e 's|^[[:space:]]*||')
+  done
+}
+
+install_perform_install() {
+  local key=
+
+  install_id "build_sources_library"
+  local build_sources_library=${variables[$key]}
+
+  install_id "build_sources_program"
+  local build_sources_program=${variables[$key]}
+
+  install_id "build_sources_headers"
+  local build_sources_headers=${variables[$key]}
+
+  install_id "build_sources_setting"
+  local build_sources_setting=${variables[$key]}
+
+  install_id "build_shared"
+  local build_shared=${variables[$key]}
+
+  install_id "build_static"
+  local build_static=${variables[$key]}
+
+  local failure=
+
+  if [[ $build_shared == "yes" ]] ; then
+    if [[ $enable_shared == "" ]] ; then
+      enable_shared="yes"
+    fi
+
+    if [[ $enable_shared == "no" ]] ; then
+      enable_shared_programs="no"
+      enable_shared_libraries="no"
+    else
+      if [[ $enable_shared_programs == "" ]] ; then
+        enable_shared_programs="yes"
+      fi
+
+      if [[ $enable_shared_libraries == "" ]] ; then
+        enable_shared_libraries="yes"
+      fi
+    fi
+  elif [[ $build_shared == "no" ]] ; then
+    if [[ $enable_shared == "" ]] ; then
+      enable_shared="no"
+    fi
+
+    if [[ $enable_shared == "no" ]] ; then
+      enable_shared_programs="no"
+      enable_shared_libraries="no"
+    else
+      if [[ $enable_shared_programs == "" ]] ; then
+        enable_shared_programs="yes"
+      fi
+
+      if [[ $enable_shared_libraries == "" ]] ; then
+        enable_shared_libraries="yes"
+      fi
+    fi
+  else
+    if [[ $enable_shared == "" ]] ; then
+      enable_shared="yes"
+    fi
+
+    if [[ $enable_shared_programs == "" ]] ; then
+      enable_shared_programs="yes"
+    fi
+
+    if [[ $enable_shared_libraries == "" ]] ; then
+      enable_shared_libraries="yes"
+    fi
+  fi
+
+  if [[ $build_static == "yes" ]] ; then
+    if [[ $enable_static == "" ]] ; then
+      enable_static="yes"
+    fi
+
+    if [[ $enable_static == "no" ]] ; then
+      enable_static_programs="no"
+      enable_static_libraries="no"
+    else
+      if [[ $enable_static_programs == "" ]] ; then
+        enable_static_programs="yes"
+      fi
+
+      if [[ $enable_static_libraries == "" ]] ; then
+        enable_static_libraries="yes"
+      fi
+    fi
+  elif [[ $build_static == "no" ]] ; then
+    if [[ $enable_static == "" ]] ; then
+      enable_static="no"
+    fi
+
+    if [[ $enable_static == "no" ]] ; then
+      enable_static_programs="no"
+      enable_static_libraries="no"
+    else
+      if [[ $enable_static_programs == "" ]] ; then
+        enable_static_programs="yes"
+      fi
+
+      if [[ $enable_static_libraries == "" ]] ; then
+        enable_static_libraries="yes"
+      fi
+    fi
+  else
+    if [[ $enable_static == "" ]] ; then
+      enable_static="yes"
+    fi
+
+    if [[ $enable_static_programs == "" ]] ; then
+      enable_static_programs="yes"
+    fi
+
+    if [[ $enable_static_libraries == "" ]] ; then
+      enable_static_libraries="yes"
+    fi
+  fi
+
+  if [[ $work != "" ]] ; then
+    if [[ $build_sources_program != "" && ( $enable_shared_programs == "yes" || $enable_static_programs == "yes" ) ]] ; then
+      if [[ ! -d ${work}programs ]] ; then
+        mkdir $verbose_common ${work}programs
+
+        if [[ $? -ne 0 ]] ; then
+          if [[ $verbosity != "quiet" ]] ; then
+            echo -e "${c_error}ERROR: Failed to create work directories ${c_notice}${work}programs${c_error}.${c_reset}"
+          fi
+
+          failure=1
+        fi
+      fi
+
+      if [[ $enable_shared_programs == "yes" && ! -d ${work}programs/shared ]] ; then
+        mkdir $verbose_common ${work}programs/shared
+
+        if [[ $? -ne 0 ]] ; then
+          if [[ $verbosity != "quiet" ]] ; then
+            echo -e "${c_error}ERROR: Failed to create work directories ${c_notice}${work}programs/shared${c_error}.${c_reset}"
+          fi
+
+          failure=1
+        fi
+      fi
+
+      if [[ $build_sources_program != "" && $enable_static_programs == "yes" && ! -d ${work}programs/static ]] ; then
+        mkdir $verbose_common ${work}programs/static
+
+        if [[ $? -ne 0 ]] ; then
+          if [[ $verbosity != "quiet" ]] ; then
+            echo -e "${c_error}ERROR: Failed to create work directories ${c_notice}${work}programs/static${c_error}.${c_reset}"
+          fi
+
+          failure=1
+        fi
+      fi
+    fi
+
+    if [[ $build_sources_library != "" && ( $enable_shared_libraries == "yes" || $enable_static_libraries == "yes" ) ]] ; then
+      if [[ ! -d ${work}libraries ]] ; then
+        mkdir $verbose_common ${work}libraries
+
+        if [[ $? -ne 0 ]] ; then
+          if [[ $verbosity != "quiet" ]] ; then
+            echo -e "${c_error}ERROR: Failed to create work directories ${c_notice}${work}libraries${c_error}.${c_reset}"
+          fi
+
+          failure=1
+        fi
+      fi
+
+      if [[ $build_sources_library != "" && $enable_shared_libraries == "yes" && ! -d ${work}libraries/shared ]] ; then
+        mkdir $verbose_common ${work}libraries/shared
+
+        if [[ $? -ne 0 ]] ; then
+          if [[ $verbosity != "quiet" ]] ; then
+            echo -e "${c_error}ERROR: Failed to create work directories ${c_notice}${work}libraries/shared${c_error}.${c_reset}"
+          fi
+
+          failure=1
+        fi
+      fi
+
+      if [[ $build_sources_library != "" && $enable_static_libraries == "yes" && ! -d ${work}libraries/static ]] ; then
+        mkdir $verbose_common ${work}libraries/static
+
+        if [[ $? -ne 0 ]] ; then
+          if [[ $verbosity != "quiet" ]] ; then
+            echo -e "${c_error}ERROR: Failed to create work directories ${c_notice}${work}libraries/static${c_error}.${c_reset}"
+          fi
+
+          failure=1
+        fi
+      fi
+    fi
+
+    if [[ $build_sources_headers != "" && $enable_includes == "yes" ]] ; then
+      if [[ ! -d ${work}includes ]] ; then
+        mkdir $verbose_common ${work}includes
+
+        if [[ $? -ne 0 ]] ; then
+          if [[ $verbosity != "quiet" ]] ; then
+            echo -e "${c_error}ERROR: Failed to create work directories ${c_notice}${work}includes${c_error}.${c_reset}"
+          fi
+
+          failure=1
+        fi
+      fi
+    fi
+
+    if [[ $failure == "" ]] ; then
+      destination_prefix=$work
+      destination_programs=${work}programs/
+      destination_programs_static=${destination_programs}static/
+      destination_programs_shared=${destination_programs}shared/
+      destination_includes=${work}includes/
+      destination_libraries=${work}libraries/
+      destination_libraries_static=${destination_libraries}static/
+      destination_libraries_shared=${destination_libraries}shared/
+    fi
+  fi
+
+  if [[ $failure == "" && $build_sources_headers != "" && $enable_includes == "yes" ]] ; then
+    if [[ $verbosity != "quiet" ]] ; then
+      echo
+      echo -e "${c_highlight}Installing Includes to: ${c_reset}${c_notice}${destination_includes}${c_reset}${c_highlight}.${c_reset}"
+    fi
+
+    cp $verbose_common -R $path_build${path_includes}* $destination_includes
+
+    if [[ $? -ne 0 ]] ; then
+      if [[ $verbosity != "quiet" ]] ; then
+        echo -e "${c_error}ERROR: Failed to copy include files from ${c_notice}${path_build}${path_includes}${c_error} to ${c_notice}${destination_includes}${c_error}.${c_reset}"
+      fi
+
+      failure=1
+    fi
+  fi
+
+  if [[ $failure == "" && $build_sources_library != "" && ( $enable_shared_libraries == "yes" || $enable_static_libraries == "yes" ) ]] ; then
+    if [[ $enable_static_libraries == "yes" ]] ; then
+      if [[ $verbosity != "quiet" ]] ; then
+        echo
+        echo -e "${c_highlight}Installing (${c_notice}static${c_highlight}) Libraries to: ${c_reset}${c_notice}${destination_libraries_static}${c_reset}${c_highlight}.${c_reset}"
+      fi
+
+      cp $verbose_common -R ${path_build}${path_libraries}${path_static}* $destination_libraries_static
+
+      if [[ $? -ne 0 ]] ; then
+        if [[ $verbosity != "quiet" ]] ; then
+          echo -e "${c_error}ERROR: Failed to copy (${c_notice}static${c_error}) library files from ${c_notice}${path_build}${path_libraries}${path_static}${c_error} to ${c_notice}${destination_libraries_static}${c_error}.${c_reset}"
+        fi
+
+        failure=1
+      fi
+    fi
+
+    if [[ $failure == "" && $build_sources_library != "" && $enable_shared_libraries == "yes" ]] ; then
+      if [[ $verbosity != "quiet" ]] ; then
+        echo
+        echo -e "${c_highlight}Installing (${c_notice}shared${c_highlight}) Libraries to: ${c_reset}${c_notice}${destination_libraries_shared}${c_reset}${c_highlight}.${c_reset}"
+      fi
+
+      cp $verbose_common -R ${path_build}${path_libraries}${path_shared}* $destination_libraries_shared
+
+      if [[ $? -ne 0 ]] ; then
+        if [[ $verbosity != "quiet" ]] ; then
+          echo -e "${c_error}ERROR: Failed to copy (${c_notice}shared${c_error}) library files from ${c_notice}${path_build}${path_libraries}${path_shared}${c_error} to ${c_notice}${destination_libraries_shared}${c_error}.${c_reset}"
+        fi
+
+        failure=1
+      fi
+    fi
+  fi
+
+  if [[ $failure == "" && $build_sources_program != "" && ( $enable_shared_programs == "yes" || $enable_static_programs == "yes" ) ]] ; then
+    if [[ $enable_static_programs == "yes" ]] ; then
+      if [[ $verbosity != "quiet" ]] ; then
+        echo
+        echo -e "${c_highlight}Installing (${c_notice}static${c_highlight}) Programs to: ${c_reset}${c_notice}${destination_programs_static}${c_reset}${c_highlight}.${c_reset}"
+      fi
+
+      cp $verbose_common -R ${path_build}${path_programs}${path_static}* $destination_programs_static
+
+      if [[ $? -ne 0 ]] ; then
+        if [[ $verbosity != "quiet" ]] ; then
+          echo -e "${c_error}ERROR: failed to copy (${c_notice}static${c_error}) program files from ${c_notice}${path_build}${path_programs}${path_static}${c_error} to ${c_notice}${destination_programs_static}${c_error}.${c_reset}"
+        fi
+
+        failure=1
+      fi
+    fi
+
+    if [[ $failure == "" && $build_sources_program != "" && $enable_shared_programs == "yes" ]] ; then
+      if [[ $verbosity != "quiet" ]] ; then
+        echo
+        echo -e "${c_highlight}Installing (${c_notice}shared${c_highlight}) Programs to: ${c_reset}${c_notice}${destination_programs_shared}${c_reset}${c_highlight}.${c_reset}"
+      fi
+
+      cp $verbose_common -R ${path_build}${path_programs}${path_shared}* $destination_programs_shared
+
+      if [[ $? -ne 0 ]] ; then
+        if [[ $verbosity != "quiet" ]] ; then
+          echo -e "${c_error}ERROR: failed to copy (${c_notice}shared${c_error}) program files from ${c_notice}${path_build}${path_programs}${path_shared}${c_error} to ${c_notice}${destination_programs_shared}${c_error}.${c_reset}"
+        fi
+
+        failure=1
+      fi
+    fi
+  fi
+
+  if [[ $failure == "" && $build_sources_setting != "" && $verbosity != "quiet" ]] ; then
+    echo
+    echo -e "${c_warning}Settings Files Detected, see: ${c_reset}${c_notice}${path_build}${path_settings}${c_reset}${c_warning}.${c_reset}"
+  fi
+
+  if [[ $failure != "" ]] ; then
+    install_cleanup
+    exit $failure
+  fi
+}
+
+install_cleanup() {
+
+  unset install_main
+  unset install_handle_colors
+  unset install_help
+  unset install_id
+  unset install_load_settings
+  unset install_perform_install
+
+  unset install_cleanup
+}
+
+install_main $*
diff --git a/licenses/cc-by-sa-4.0 b/licenses/cc-by-sa-4.0
new file mode 100644 (file)
index 0000000..e672f4e
--- /dev/null
@@ -0,0 +1,4 @@
+Creative Commons Attribution Share Alike 4.0 International
+
+see: https://creativecommons.org/licenses/by-sa/4.0/
+see: https://creativecommons.org/licenses/by-sa/4.0/legalcode
diff --git a/licenses/lgpl-2.1-or-later b/licenses/lgpl-2.1-or-later
new file mode 100644 (file)
index 0000000..602bfc9
--- /dev/null
@@ -0,0 +1,504 @@
+                 GNU LESSER GENERAL PUBLIC LICENSE
+                      Version 2.1, February 1999
+
+ Copyright (C) 1991, 1999 Free Software Foundation, Inc.
+ 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+[This is the first released version of the Lesser GPL.  It also counts
+ as the successor of the GNU Library Public License, version 2, hence
+ the version number 2.1.]
+
+                           Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+Licenses are intended to guarantee your freedom to share and change
+free software--to make sure the software is free for all its users.
+
+  This license, the Lesser General Public License, applies to some
+specially designated software packages--typically libraries--of the
+Free Software Foundation and other authors who decide to use it.  You
+can use it too, but we suggest you first think carefully about whether
+this license or the ordinary General Public License is the better
+strategy to use in any particular case, based on the explanations below.
+
+  When we speak of free software, we are referring to freedom of use,
+not price.  Our General Public Licenses are designed to make sure that
+you have the freedom to distribute copies of free software (and charge
+for this service if you wish); that you receive source code or can get
+it if you want it; that you can change the software and use pieces of
+it in new free programs; and that you are informed that you can do
+these things.
+
+  To protect your rights, we need to make restrictions that forbid
+distributors to deny you these rights or to ask you to surrender these
+rights.  These restrictions translate to certain responsibilities for
+you if you distribute copies of the library or if you modify it.
+
+  For example, if you distribute copies of the library, whether gratis
+or for a fee, you must give the recipients all the rights that we gave
+you.  You must make sure that they, too, receive or can get the source
+code.  If you link other code with the library, you must provide
+complete object files to the recipients, so that they can relink them
+with the library after making changes to the library and recompiling
+it.  And you must show them these terms so they know their rights.
+
+  We protect your rights with a two-step method: (1) we copyright the
+library, and (2) we offer you this license, which gives you legal
+permission to copy, distribute and/or modify the library.
+
+  To protect each distributor, we want to make it very clear that
+there is no warranty for the free library.  Also, if the library is
+modified by someone else and passed on, the recipients should know
+that what they have is not the original version, so that the original
+author's reputation will not be affected by problems that might be
+introduced by others.
+\f
+  Finally, software patents pose a constant threat to the existence of
+any free program.  We wish to make sure that a company cannot
+effectively restrict the users of a free program by obtaining a
+restrictive license from a patent holder.  Therefore, we insist that
+any patent license obtained for a version of the library must be
+consistent with the full freedom of use specified in this license.
+
+  Most GNU software, including some libraries, is covered by the
+ordinary GNU General Public License.  This license, the GNU Lesser
+General Public License, applies to certain designated libraries, and
+is quite different from the ordinary General Public License.  We use
+this license for certain libraries in order to permit linking those
+libraries into non-free programs.
+
+  When a program is linked with a library, whether statically or using
+a shared library, the combination of the two is legally speaking a
+combined work, a derivative of the original library.  The ordinary
+General Public License therefore permits such linking only if the
+entire combination fits its criteria of freedom.  The Lesser General
+Public License permits more lax criteria for linking other code with
+the library.
+
+  We call this license the "Lesser" General Public License because it
+does Less to protect the user's freedom than the ordinary General
+Public License.  It also provides other free software developers Less
+of an advantage over competing non-free programs.  These disadvantages
+are the reason we use the ordinary General Public License for many
+libraries.  However, the Lesser license provides advantages in certain
+special circumstances.
+
+  For example, on rare occasions, there may be a special need to
+encourage the widest possible use of a certain library, so that it becomes
+a de-facto standard.  To achieve this, non-free programs must be
+allowed to use the library.  A more frequent case is that a free
+library does the same job as widely used non-free libraries.  In this
+case, there is little to gain by limiting the free library to free
+software only, so we use the Lesser General Public License.
+
+  In other cases, permission to use a particular library in non-free
+programs enables a greater number of people to use a large body of
+free software.  For example, permission to use the GNU C Library in
+non-free programs enables many more people to use the whole GNU
+operating system, as well as its variant, the GNU/Linux operating
+system.
+
+  Although the Lesser General Public License is Less protective of the
+users' freedom, it does ensure that the user of a program that is
+linked with the Library has the freedom and the wherewithal to run
+that program using a modified version of the Library.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.  Pay close attention to the difference between a
+"work based on the library" and a "work that uses the library".  The
+former contains code derived from the library, whereas the latter must
+be combined with the library in order to run.
+\f
+                 GNU LESSER GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License Agreement applies to any software library or other
+program which contains a notice placed by the copyright holder or
+other authorized party saying it may be distributed under the terms of
+this Lesser General Public License (also called "this License").
+Each licensee is addressed as "you".
+
+  A "library" means a collection of software functions and/or data
+prepared so as to be conveniently linked with application programs
+(which use some of those functions and data) to form executables.
+
+  The "Library", below, refers to any such software library or work
+which has been distributed under these terms.  A "work based on the
+Library" means either the Library or any derivative work under
+copyright law: that is to say, a work containing the Library or a
+portion of it, either verbatim or with modifications and/or translated
+straightforwardly into another language.  (Hereinafter, translation is
+included without limitation in the term "modification".)
+
+  "Source code" for a work means the preferred form of the work for
+making modifications to it.  For a library, complete source code means
+all the source code for all modules it contains, plus any associated
+interface definition files, plus the scripts used to control compilation
+and installation of the library.
+
+  Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running a program using the Library is not restricted, and output from
+such a program is covered only if its contents constitute a work based
+on the Library (independent of the use of the Library in a tool for
+writing it).  Whether that is true depends on what the Library does
+and what the program that uses the Library does.
+
+  1. You may copy and distribute verbatim copies of the Library's
+complete source code as you receive it, in any medium, provided that
+you conspicuously and appropriately publish on each copy an
+appropriate copyright notice and disclaimer of warranty; keep intact
+all the notices that refer to this License and to the absence of any
+warranty; and distribute a copy of this License along with the
+Library.
+
+  You may charge a fee for the physical act of transferring a copy,
+and you may at your option offer warranty protection in exchange for a
+fee.
+\f
+  2. You may modify your copy or copies of the Library or any portion
+of it, thus forming a work based on the Library, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) The modified work must itself be a software library.
+
+    b) You must cause the files modified to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    c) You must cause the whole of the work to be licensed at no
+    charge to all third parties under the terms of this License.
+
+    d) If a facility in the modified Library refers to a function or a
+    table of data to be supplied by an application program that uses
+    the facility, other than as an argument passed when the facility
+    is invoked, then you must make a good faith effort to ensure that,
+    in the event an application does not supply such function or
+    table, the facility still operates, and performs whatever part of
+    its purpose remains meaningful.
+
+    (For example, a function in a library to compute square roots has
+    a purpose that is entirely well-defined independent of the
+    application.  Therefore, Subsection 2d requires that any
+    application-supplied function or table used by this function must
+    be optional: if the application does not supply it, the square
+    root function must still compute square roots.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Library,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Library, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote
+it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Library.
+
+In addition, mere aggregation of another work not based on the Library
+with the Library (or with a work based on the Library) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may opt to apply the terms of the ordinary GNU General Public
+License instead of this License to a given copy of the Library.  To do
+this, you must alter all the notices that refer to this License, so
+that they refer to the ordinary GNU General Public License, version 2,
+instead of to this License.  (If a newer version than version 2 of the
+ordinary GNU General Public License has appeared, then you can specify
+that version instead if you wish.)  Do not make any other change in
+these notices.
+\f
+  Once this change is made in a given copy, it is irreversible for
+that copy, so the ordinary GNU General Public License applies to all
+subsequent copies and derivative works made from that copy.
+
+  This option is useful when you wish to copy part of the code of
+the Library into a program that is not a library.
+
+  4. You may copy and distribute the Library (or a portion or
+derivative of it, under Section 2) in object code or executable form
+under the terms of Sections 1 and 2 above provided that you accompany
+it with the complete corresponding machine-readable source code, which
+must be distributed under the terms of Sections 1 and 2 above on a
+medium customarily used for software interchange.
+
+  If distribution of object code is made by offering access to copy
+from a designated place, then offering equivalent access to copy the
+source code from the same place satisfies the requirement to
+distribute the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  5. A program that contains no derivative of any portion of the
+Library, but is designed to work with the Library by being compiled or
+linked with it, is called a "work that uses the Library".  Such a
+work, in isolation, is not a derivative work of the Library, and
+therefore falls outside the scope of this License.
+
+  However, linking a "work that uses the Library" with the Library
+creates an executable that is a derivative of the Library (because it
+contains portions of the Library), rather than a "work that uses the
+library".  The executable is therefore covered by this License.
+Section 6 states terms for distribution of such executables.
+
+  When a "work that uses the Library" uses material from a header file
+that is part of the Library, the object code for the work may be a
+derivative work of the Library even though the source code is not.
+Whether this is true is especially significant if the work can be
+linked without the Library, or if the work is itself a library.  The
+threshold for this to be true is not precisely defined by law.
+
+  If such an object file uses only numerical parameters, data
+structure layouts and accessors, and small macros and small inline
+functions (ten lines or less in length), then the use of the object
+file is unrestricted, regardless of whether it is legally a derivative
+work.  (Executables containing this object code plus portions of the
+Library will still fall under Section 6.)
+
+  Otherwise, if the work is a derivative of the Library, you may
+distribute the object code for the work under the terms of Section 6.
+Any executables containing that work also fall under Section 6,
+whether or not they are linked directly with the Library itself.
+\f
+  6. As an exception to the Sections above, you may also combine or
+link a "work that uses the Library" with the Library to produce a
+work containing portions of the Library, and distribute that work
+under terms of your choice, provided that the terms permit
+modification of the work for the customer's own use and reverse
+engineering for debugging such modifications.
+
+  You must give prominent notice with each copy of the work that the
+Library is used in it and that the Library and its use are covered by
+this License.  You must supply a copy of this License.  If the work
+during execution displays copyright notices, you must include the
+copyright notice for the Library among them, as well as a reference
+directing the user to the copy of this License.  Also, you must do one
+of these things:
+
+    a) Accompany the work with the complete corresponding
+    machine-readable source code for the Library including whatever
+    changes were used in the work (which must be distributed under
+    Sections 1 and 2 above); and, if the work is an executable linked
+    with the Library, with the complete machine-readable "work that
+    uses the Library", as object code and/or source code, so that the
+    user can modify the Library and then relink to produce a modified
+    executable containing the modified Library.  (It is understood
+    that the user who changes the contents of definitions files in the
+    Library will not necessarily be able to recompile the application
+    to use the modified definitions.)
+
+    b) Use a suitable shared library mechanism for linking with the
+    Library.  A suitable mechanism is one that (1) uses at run time a
+    copy of the library already present on the user's computer system,
+    rather than copying library functions into the executable, and (2)
+    will operate properly with a modified version of the library, if
+    the user installs one, as long as the modified version is
+    interface-compatible with the version that the work was made with.
+
+    c) Accompany the work with a written offer, valid for at
+    least three years, to give the same user the materials
+    specified in Subsection 6a, above, for a charge no more
+    than the cost of performing this distribution.
+
+    d) If distribution of the work is made by offering access to copy
+    from a designated place, offer equivalent access to copy the above
+    specified materials from the same place.
+
+    e) Verify that the user has already received a copy of these
+    materials or that you have already sent this user a copy.
+
+  For an executable, the required form of the "work that uses the
+Library" must include any data and utility programs needed for
+reproducing the executable from it.  However, as a special exception,
+the materials to be distributed need not include anything that is
+normally distributed (in either source or binary form) with the major
+components (compiler, kernel, and so on) of the operating system on
+which the executable runs, unless that component itself accompanies
+the executable.
+
+  It may happen that this requirement contradicts the license
+restrictions of other proprietary libraries that do not normally
+accompany the operating system.  Such a contradiction means you cannot
+use both them and the Library together in an executable that you
+distribute.
+\f
+  7. You may place library facilities that are a work based on the
+Library side-by-side in a single library together with other library
+facilities not covered by this License, and distribute such a combined
+library, provided that the separate distribution of the work based on
+the Library and of the other library facilities is otherwise
+permitted, and provided that you do these two things:
+
+    a) Accompany the combined library with a copy of the same work
+    based on the Library, uncombined with any other library
+    facilities.  This must be distributed under the terms of the
+    Sections above.
+
+    b) Give prominent notice with the combined library of the fact
+    that part of it is a work based on the Library, and explaining
+    where to find the accompanying uncombined form of the same work.
+
+  8. You may not copy, modify, sublicense, link with, or distribute
+the Library except as expressly provided under this License.  Any
+attempt otherwise to copy, modify, sublicense, link with, or
+distribute the Library is void, and will automatically terminate your
+rights under this License.  However, parties who have received copies,
+or rights, from you under this License will not have their licenses
+terminated so long as such parties remain in full compliance.
+
+  9. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Library or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Library (or any work based on the
+Library), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Library or works based on it.
+
+  10. Each time you redistribute the Library (or any work based on the
+Library), the recipient automatically receives a license from the
+original licensor to copy, distribute, link with or modify the Library
+subject to these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties with
+this License.
+\f
+  11. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Library at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Library by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Library.
+
+If any portion of this section is held invalid or unenforceable under any
+particular circumstance, the balance of the section is intended to apply,
+and the section as a whole is intended to apply in other circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  12. If the distribution and/or use of the Library is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Library under this License may add
+an explicit geographical distribution limitation excluding those countries,
+so that distribution is permitted only in or among countries not thus
+excluded.  In such case, this License incorporates the limitation as if
+written in the body of this License.
+
+  13. The Free Software Foundation may publish revised and/or new
+versions of the Lesser General Public License from time to time.
+Such new versions will be similar in spirit to the present version,
+but may differ in detail to address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Library
+specifies a version number of this License which applies to it and
+"any later version", you have the option of following the terms and
+conditions either of that version or of any later version published by
+the Free Software Foundation.  If the Library does not specify a
+license version number, you may choose any version ever published by
+the Free Software Foundation.
+\f
+  14. If you wish to incorporate parts of the Library into other free
+programs whose distribution conditions are incompatible with these,
+write to the author to ask for permission.  For software which is
+copyrighted by the Free Software Foundation, write to the Free
+Software Foundation; we sometimes make exceptions for this.  Our
+decision will be guided by the two goals of preserving the free status
+of all derivatives of our free software and of promoting the sharing
+and reuse of software generally.
+
+                           NO WARRANTY
+
+  15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO
+WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.
+EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR
+OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY
+KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
+LIBRARY IS WITH YOU.  SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME
+THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
+WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY
+AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU
+FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
+CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE
+LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
+RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
+FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
+SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
+DAMAGES.
+
+                    END OF TERMS AND CONDITIONS
+\f
+           How to Apply These Terms to Your New Libraries
+
+  If you develop a new library, and you want it to be of the greatest
+possible use to the public, we recommend making it free software that
+everyone can redistribute and change.  You can do so by permitting
+redistribution under these terms (or, alternatively, under the terms of the
+ordinary General Public License).
+
+  To apply these terms, attach the following notices to the library.  It is
+safest to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least the
+"copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the library's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Lesser General Public
+    License as published by the Free Software Foundation; either
+    version 2.1 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public
+    License along with this library; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+
+Also add information on how to contact you by electronic and paper mail.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the library, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the
+  library `Frob' (a library for tweaking knobs) written by James Random Hacker.
+
+  <signature of Ty Coon>, 1 April 1990
+  Ty Coon, President of Vice
+
+That's all there is to it!
+
+
diff --git a/licenses/open-standard-license-1.0 b/licenses/open-standard-license-1.0
new file mode 100644 (file)
index 0000000..f96b9f1
--- /dev/null
@@ -0,0 +1,37 @@
+Open Standard License 1.0 (Informal Draft version 0.5).
+  March 2022.
+
+This is an informal document representing the not yet formalized Open Standard License 1.0.
+This license applies to the Standards and their Specifications and designates legal requirements on Implementations of the Standard and their respective Specifications.
+
+Terminology:
+- Standard: A set of rules and guidelines.
+- Specification: A specific interpretation or clarification of a Standard, such as the documentation that describes how to use or follow a Standard.
+- Implementation: The applying of some Standard or Specification.
+- API: Application Programming Interface*.
+- ABI: Application Binary Interface**.
+- Service: Any action or labor performed by one party for another party (such as one person helping another person).
+- Protocol: In the context of computers and software, this is a Standard focused on communication between two parties (often referring to Internet communication).
+
+* The API term is commonly mis-represented as Services or Protocols (such as "Web API").
+  An API instructs a programmer how to use a dependency when programming some software that utilizes said dependency.
+  An API is a Specification of some Implementation of a Standard be it a formally defined standard or an informally defined standard.
+  An API may be an Implementation of a Standard or a part of an Implementation of a Standard.
+  An API is, in effect, documentation.
+
+** The ABI term refers to an Application Binary Interface and represents the compiled implementation of some API.
+  An ABI may not always exist for some API, such as for pure scripting languages.
+  An ABI is neither a Specification nor a Standard.
+  An ABI is an Implementation of an API making it an Implementation of a Standard or Specification.
+
+Principles of the license:
+  - The Standard or Specification must be freely and publicly available to use and implement.
+  - All patents associated must be royalty-free for unrestricted use and must not impose any restrictions on any third party's implementation of this Standard beyond those described in the license.
+  - There must be no agreements or requirements for the execution of the license grant, including: NDA, grant, click-through, or any form of paperwork (including all non-paper forms of paperwork, such as digital forms).
+  - There must be no restrictions on the form of an Implementation of a Standard or Specification.
+  - The license shall prohibit any form of restricting any parties access to use, implement, extend, or deviate from this standard unless:
+    - Restricted by this license.
+    - Unless there is a breach of license conditions.
+  - The license is irrevocable unless there is a breach of the license conditions.
+  - The license does not grant any kind of warranty or liability under any circumstances to any party for any reason, be it direct, indirect, consequential, incidental, or in any other form.
+  - The license does not restrict any party from optionally providing their own warranty or liability on some Implementation but such warranties or liabilities are completely separate and independent of this license.